define([
	"dojo/_base/declare",
	"thornberry/app/_Module",
	"thornberry/app/Component/LazyLoadView",
	"thornberry/app/Component/AccountsReceivable/Dashboard",
	"thornberry/app/Component/AccountsReceivable/AccountsView",
	//"thornberry/app/Component/AccountsReceivable/PaymentsAdjustmentsView",
	"thornberry/app/Component/AccountsReceivable/EraView"
],function(
	declare,
	_Module,
	LazyLoadView,
	Dashboard,
	AccountsView,
	//PaymentsAdjustmentsView,
	EraView
) {
	return declare(_Module,{
		title: "Accounts Receivable",

		initViews: function(page) {
			var viewMap = {};
			var props = {
				props: {
					onSetViewFilters: function(viewName,filters) {
						var view = viewMap[viewName];
						if (view) {
							view.load().set({
								props: {
									filters: filters
								}
							});
						}
					},
					onUpdateData: function() {
						for (var viewName in viewMap) {
							viewMap[viewName].instance.refreshData();
						}
					}
				}
			};

			viewMap["Dashboard"]			= new LazyLoadView({ viewClass: Dashboard,					title: "Dashboard",				props: props });
			viewMap["Accounts"]  			= new LazyLoadView({ viewClass: AccountsView,				title: "Accounts",				props: props,   preload: true });
			//viewMap["PaymentsAdjustments"]  = new LazyLoadView({ viewClass: PaymentsAdjustmentsView,	title: "Payments/Adjustments",	props: props,   preload: true });
			viewMap["Era"]					= new LazyLoadView({ viewClass: EraView,					title: "ERA",					props: props,   preload: true });

			page.pushViewContainers([
				viewMap["Dashboard"],
				viewMap["Accounts"],
				//viewMap["PaymentsAdjustments"],
				viewMap["Era"]
			]);
		}
	});
});