define([
    "dojo/_base/declare",
    "thornberry/app/Component/_Component",
    "thornberry/app/Component/_DataFormMixin",
    "dijit/_TemplatedMixin",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/dom-style",
    "dojo/text!./Templates/EraAdjustmentDetailItem.html",
    "dojo/text!./Templates/EraPaymentDetailItem.html",
    "dijit/form/DateTextBox",
    "dojo/NodeList-dom"
],function(
    declare,
    _Component,
    _DataFormMixin,
    _TemplatedMixin,
    lang,
    query,
    domStyle,
    adjustmentTemplate,
    paymentTemplate
) {
    return declare([_Component,_TemplatedMixin,_DataFormMixin], {
        templateString: "",

        type: "adjustment", // adjustment or payment

        value: null,

        postMixInProperties: function() {
            var t = this;
            t.templateString = (t.type === "adjustment" ? adjustmentTemplate : paymentTemplate);
        },

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                value: null,
                category: null,
                firstInSection: false,
                postToAr: false,
                balance: null
            });
        },

        refreshRendering: function() {
            var t = this;

            if (t.props.value) {
                t.props.value.balance = t.props.balance;
                t.set("value",t.props.value);
                if (t.domNode) {
                    query(".field-name",t.domNode).style("display",t.props.firstInSection ? "" : "none");
                }
            }
            if (t.domNode) {
                domStyle.set(t.amountNode,"color",t.props.postToAr ? "black" : "gray");
            }
            t.inherited(arguments);
        },

        _setValueAttr: function(value) {
            var t = this;
            if (t.props.category && t.type === "adjustment") {
                value.category = t.props.category;
            }
            t.inherited(arguments,[value]);
            t.value = value;
        }
    });
});