define([
    "dojo/_base/declare",
    "thornberry/app/Component/_EditorComponent",
    "thornberry/app/Component/_TableFieldEditorMixin",
    "thornberry/app/Component/_DataFormMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dojo/_base/lang",
    "dojo/query",
    "dojo/text!./Templates/EraItemEditor.html",
    "dijit/form/DateTextBox",
    "dojo/NodeList-dom"
],function(
    declare,
    _EditorComponent,
    _TableFieldEditorMixin,
    _DataFormMixin,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    lang,
    query,
    template
) {
    return declare([_EditorComponent,_TemplatedMixin,_WidgetsInTemplateMixin,_TableFieldEditorMixin,_DataFormMixin], {
        templateString: template,

        code: null,

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                value: null,
                category: null,
                firstInSection: false
            });
        },

        getPageProps: function() {
            return lang.mixin(this.inherited(arguments),{
                
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);

            t.addTableFilter("actionId",function(name,item,value) {
                return (item.active == "Yes" && item.adjustmentAction == true) || item.id == value;
            });
            t.addTableFilter("adjustmentTypeId",function(name,item,value) {
                return (item.active == "Yes" && (item.reasonCode == "" || (t.props.value && item.reasonCode == t.props.value.code))) || item.id == value;
            });

            t.addLogic("adjustmentTypeId",function(name,value,values,loading) {
                if (loading && !t.props.disabled) {
                    var results = t.tableManager.get("Tables.AdjustmentType").query({reasonCode:values.code});
                    if (results.length) {
                        t.defer(function() {
                            t.setFormValue("adjustmentTypeId",results[0].id,true);
                        });
                    }
                }
            },true);

            t.addLogic("actionId",function(name,value) {
                var item = t.getSelectedItem("actionId");
                if (item && item.allowPost != 1) {
                    t.setFormValue("adjustmentTypeId","");
                }
            });

            t.addRequirement(null,true);
            t.addDisabled("adjustmentTypeId",function() {
                var item = t.getSelectedItem("actionId");
                return (item && item.allowPost != 1);
            });
        },

        updateModified: function(subClassValue) {
            this.inherited(arguments,[true]);
        },

        refreshRendering: function() {
            var t = this;
            if (t.domNode) {
                query(".field-name",t.domNode).style("display",t.props.firstInSection ? "" : "none");
            }
            if (t.props.value) {
                t.set("code",t.props.value.code);
            }
            t.inherited(arguments);
        },

        _setValueAttr: function(value) {
            var t = this;
            if (t.props.category) {
                value.category = t.props.category;
            }
            t.inherited(arguments,[value]);
        }
    });
});