define([
    "dojo/_base/declare",
    "thornberry/app/Component/_Component",
    "thornberry/app/Component/_DataFormMixin",
    "dijit/_TemplatedMixin",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/text!./Templates/EraRecordView.html",
    "./EraDetailItem"
],function(
    declare,
    _Component,
    _DataFormMixin,
    _TemplatedMixin,
    lang,
    arrayUtils,
    domStyle,
    template,
    EraDetailItem
) {
    return declare([_Component,_TemplatedMixin,_DataFormMixin], {
        templateString: template,

        detailAdjustmentItems: null,
        detailPaymentItems: null,

        constructor: function() {
            var t = this;
            t.detailAdjustmentItems = [];
            t.detailPaymentItems = [];
        },

        getInitialProps: function() {
            return lang.mixin(this.inherited(arguments),{
                value: null,
                paymentAction: null,
                adjustmentActions: null
            });
        },

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);


        },

        refreshRendering: function() {
            var t = this;
            if (t.props.value && t.props.value != t.value) {
                arrayUtils.forEach(t.detailAdjustmentItems,function(item) { item.destroy(); });
                arrayUtils.forEach(t.detailPaymentItems,function(item) { item.destroy(); });
                t.detailAdjustmentItems = [];
                t.detailPaymentItems = [];

                var count = 0;
                for (var category in t.props.value.adjustments) {
                    var firstInSection = true;
                    arrayUtils.forEach(t.props.value.adjustments[category],function(adjustment) {
                        var item = new EraDetailItem({
                            type: "adjustment",
                            props: {
                                value: adjustment,
                                category: category,
                                firstInSection: firstInSection
                            }
                        });
                        t.detailAdjustmentItems.push(item);
                        t.adjustmentDetailContainer.appendChild(item.domNode);
                        firstInSection = false;
                        count++;
                    });
                }
                domStyle.set(t.adjustmentContainer,"display",count > 0 ? "" : "none");

                count = 0;
                firstInSection = true;
                arrayUtils.forEach(t.props.value.payments,function(payment) {
                    var item = new EraDetailItem({
                        type: "payment",
                        props: {
                            value: payment,
                            firstInSection: firstInSection
                        }
                    });
                    t.detailPaymentItems.push(item);
                    t.paymentDetailContainer.appendChild(item.domNode);
                    firstInSection = false;
                    count++;
                });

                domStyle.set(t.paymentContainer,"display",count > 0 ? "" : "none");
            }
            if (t.props.value && t.domNode) {
                t.updateBalance();
                //domStyle.set(t.amountNode,"color",t.props.paymentAction && t.props.paymentAction.postToAr ? "black" : "gray");
                t.set("value",t.props.value);
            }
            t.inherited(arguments);
        },

        _setValueAttr: function(value) {
            var t = this;
            t.value = value;
            t.inherited(arguments);
        },

        updateBalance: function() {
            var t = this;
            if (t.value && t.props) {
                var balance = t.value.startingBalance;
                arrayUtils.forEach(t.detailAdjustmentItems,function(item) {
                    var value = item.get("value");
                    if (value) {
                        var action = t.props.adjustmentActions[value.code];
                        if (action && action.postToAr) {
                            balance -= value.amount;
                        }
                        props = { balance : balance, postToAr: (action && action.postToAr) }
                        item.set("props",props);
                    }
                });
                arrayUtils.forEach(t.detailPaymentItems,function(item) {
                    var value = item.get("value");
                    if (value) {
                        if (t.props.paymentAction.postToAr) {
                            balance -= value.amount;
                        }
                        props = { balance : balance, postToAr: t.props.paymentAction.postToAr }
                        item.set("props",props);
                    }
                });
                /*if (t.props.paymentAction && t.props.paymentAction.postToAr) {
                    balance -= t.value.paymentAmount;
                }*/
                t.props.value.balance = balance;
                t.props.value.endingBalance = balance;
            }
        }
    });
});