define([
	"dojo/_base/declare",
	"dojo/_base/lang",
	"thornberry/app/Component/_Component",
	"thornberry/app/Component/_EditorViewMixin",
	"thornberry/app/Component/AccountsReceivable/PrePaymentEditor",
	"thornberry/app/Service/AccountsReceivable",
],function(
	declare,
	lang,
	Component,
	_EditorViewMixin,
	PrePaymentEditor,
	service
) {
	return declare([Component, _EditorViewMixin], {
		title: "Create Pre-Payment Account",

		EditorClass: PrePaymentEditor,
		lockCheckEnabled: true,
		objectType: "Billing.AccountsReceivable.Account",

		account: null,

		getTitle: function() {
			return this.title;
		},

		getPageProps: function() {
			var t = this;
			return lang.mixin(t.inherited(arguments),{
				accountSummaryShown: false
			});
		},

		refreshRendering: function() {
            var t = this;
            if (t.isShown) {
                t.set("objectId",t.props.objectId);

                t.editor.set("props", {
                    value: null,
                    mode: "add"
                });
            }
            t.inherited(arguments);
        },

		save: function() {
			var t = this;
			return service.savePrePayment(t.editor.get("value"));
		}
	});
});