define([
	"dojo/_base/declare",
	"thornberry/app/Component/_EditorComponent",
	"dijit/_TemplatedMixin",
	"dijit/_WidgetsInTemplateMixin",
	"thornberry/app/Component/_TableFieldEditorMixin",
	"dojo/text!./Templates/PrePaymentEditor.html",
	"thornberry/editor/property/PatientSearch",
	"thornberry/serverRequest",
	"thornberry/app/utils",
	"thornberry/form/searchBox",
	"dijit/form/ValidationTextBox",
	"dojo/store/Memory",
	"dojo/when",
	"dojo/dom-style",
	"dijit/form/Form",
	"dijit/form/Select",
	"dijit/form/DateTextBox",
	"dijit/form/CurrencyTextBox"
],function(
	declare,
	_EditorComponent,
	_TemplatedMixin,
	_WidgetsInTemplateMixin,
	_TableFieldEditorMixin,
	template,
	PatientSearch,
	serverRequest,
	utils
){
	return declare([_EditorComponent, _TemplatedMixin, _WidgetsInTemplateMixin, _TableFieldEditorMixin], {
		templateString: template,

		_requestInProgress: false,

		buildRendering: function() {
			var t = this;
			t.inherited(arguments);

			t.patientSearch = new PatientSearch({
				name: "ndocNum",
				reset: function() {
					this.deserialize("");
				},
				buildRendering: function() {
					var t = this;
					t.inherited("buildRendering", arguments);
					t.reqBkgdNode = t.searchInput.domNode;
				},
				_add: function(selection, noEvent) {
					var t = this;
					t.inherited("_add", arguments, [selection, true]);
					if (selection !== null && !noEvent) {
						t.emit("change", selection.value);
					}
				}
			}, t.patientNode);
			t.patientSearch.startup();

			t.addTableFilter("paymentType", function(name, tableItem, value) {
				return tableItem.IsPrePayment; 
			});

			t.addLogic("ndocNum",function(name, value) {
				t.setFormValue("insurance", "", true);
				t._requestInProgress = true;
				serverRequest("Billing.AccountsReceivable.Service", "GetPolicies", value).then(function(results) {
					t._requestInProgress = false;
					t.setTable("insurance", results, ["insurance"]);
					t.invalidate("fieldState");
				},function(error) {
					utils.showMessage(error);
					t._requestInProgress = false;
				});
			},true);

			t.addRequirement(["ndocNum", "insurance", "paymentType", "paymentDate", "paymentAmount"], true);
		}
	});
});